#include <iostream>
using namespace std;

/** Scrivere una funzione che inserisce in un array una sequenza
    di interi maggiori di 0 letti da "cin", fintanto che non si e'
    raggiunta la dimensione massima dell'array oppure si legge il
    numero 0 */
void fun1(int array[], const unsigned int dim)
{
  for (int i=0; i<dim; ++i) {
    int val;
    cout << i+1 << "/" << dim << ": inserire un numero positivo (0 esce): ";
    cin >> val;
    if (val == 0) break;
    if (val > 0) array[i] = val;
    else {
      cout << "Errore: il numero deve essere positivo\n";
      i -= 1; // resta a i corrente      
    }
  }
}


/** Scrivere una funzione che prende come argomento un array di
    interi e la sua dimensione e lo stampa su 'cout' */
void fun2(const int array[], const unsigned int dim)
{
  for (int i=0; i<dim; ++i) {
    cout << array[i] << " ";
  }
  cout << endl;
}

/** Scrivere una funzione che dato un array di interi ed un intero
    rappresentante una posizione (quindi minore della dimensione
    dell'array) e restituisce la lunghezza della massima
    sottosequenza crescente che inizia da pos se pos e' minore
    della lunghezza dell' array, altrimenti ritorna -1. 

    - E.g. A={1,3,4,2,5,6,7,8}
      SottoSeq(A, dim, 0) := 1	
      SottoSeq(A, dim, 1) := 2	
      SottoSeq(A, dim, 4) := 4	
      SottoSeq(A, dim, dim) := -1
*/
int fun3(const int array[], const unsigned int dim, const unsigned int pos)
{
  if (pos >= dim) return -1;
  
  // cicla fino al penultimo:
  int i;
  for (i=pos; i<dim-1; ++i) {
    if ((array[i]+1) != array[i+1]) break; // fine sequenza crescente
  }
  return i-pos+1;
}


// Test
int main()
{
  const int DIM = 5;
  int arr[DIM];
  
  cout << "Inserimento array:\n";
  fun1(arr, DIM);
  
  cout << "\nStampa array:\n";
  fun2(arr, DIM);

  cout << "\nSotto-sequenze crescenti:\n";
  // qui testiamo anche i==DIM
  for (int i=0; i<=DIM; ++i) {
    int seq_len = fun3(arr, DIM, i);
    cout << "SottoSeq(arr, " << DIM << ", " << i << ") := " 
         << seq_len << endl;
  }

  cout << endl;
  return 0;
}
