#include <iostream>
using namespace std;

/* ---------------------------------------------------------------------- */
/* Funzioni di utilita'                                                   */
/* ---------------------------------------------------------------------- */

/** Restituisce un carattere pseudo-casuale in "AGCT" */
char random_char() 
{
  const char names[] = "AGCT";
  // strlen restituisce la lunghezza della stringa passata
  return names[rand() % strlen(names)]; 
}

void stampa_array_char(char arr[], const unsigned int dim)
{
  for (int i=0; i<dim; ++i) cout << arr[i];
}


/* ---------------------------------------------------------------------- */
/* Esercizi svolti                                                        */
/* ---------------------------------------------------------------------- */

/** Scrivere una funzione/procedura che crei una sequenza random
    di DNA */
void fun1(char seq[], const unsigned int dim)
{
  for (int i=0; i<dim; ++i) seq[i] = random_char();
}


/** Elimina dall'array le prime n occorrenze del carattere
    passato. Se n=-1 allora tutte le occorrenze verranno eliminate. 
    La funzione e' utilizzata dalle domande 2 e 3. 
    
    Restituisce il numero di occorrenze rimosse */
int fun2(char seq[], const unsigned int dim, int n, char c)
{
  int rem = 0;
  int ir, iw;

  /* si utilizzano due indici per scorrere l'array. Un indice
     serve per leggere l'array, e si incrementa ad ogni ciclo,
     mentre l'altro indice serve a scrivere nell'array, per
     eliminare i caratteri */
  for (ir=0, iw=0; ir < dim; ++ir) {

    // Il carattere non e' quello che cerchiamo, 
    // oppure abbiamo gia' rimosso il numero massimo di occorrenze
    if (seq[ir] != c || (rem >= n && n != -1) ) {
      // scriviamo se serve, e muoviamo iw avanti
      if (ir != iw) seq[iw] = seq[ir];
      iw += 1;
    }
    else {
      // il carattere va rimosso, lasciamo fermo iw e contiamo la rimozione
      rem += 1;
    }      
  }
  
  // azzera i caratteri che restano in fondo (tra iw e dim-1)
  for (int i=iw; i<dim; ++i) seq[i] = '\0';

  return rem;
}


/** Restituisce il numero di occorrenze del carattere dato
    nell'array */
int fun3(const char arr[], const unsigned int dim, char c)
{
  int res = 0;
  for (int i=0; i<dim; ++i) if (arr[i] == c) res += 1;
  return res;
}


int main()
{
  const unsigned int dim = 20;
  char arr[dim];

  // setta il seme dei numeri random:
  srand(getpid());

  // --------------------------------------------------
  // init
  fun1(arr, dim);
  stampa_array_char(arr, dim);
  cout << endl;

  // domanda 2
  int occ;
  cout << "Rimuovo la prima occorrenza di 'A'\n";
  occ = fun2(arr, dim, 1, 'A');
  cout << "Rimosse " << occ << " occorrenze\n";
  stampa_array_char(arr, dim);
  cout << endl;

  // --------------------------------------------------
  // reinit
  fun1(arr, dim);
  cout << endl;
  stampa_array_char(arr, dim);
  cout << endl;

  // domanda 3
  cout << "Rimuovo tutte le occorrenze di 'A'\n";
  occ = fun2(arr, dim, -1, 'A');
  cout << "Rimosse " << occ << " occorrenze\n";
  stampa_array_char(arr, dim);
  cout << endl;

  // --------------------------------------------------
  // reinit
  fun1(arr, dim);
  cout << endl;
  stampa_array_char(arr, dim);
  cout << endl;

  // domanda 4:
  char letters[] = "AGCT";
  int num = strlen(letters);
  for (int i=0; i<num; ++i) {
    cout << letters[i] << " = " << fun3(arr, dim, letters[i]);
    if (i < num -1) cout << ", "; // non l'ultimo elemento
  }
  cout << endl;
}
