#include <iostream>
using namespace std;

/* ---------------------------------------------------------------------- */
/* Funzioni di utilita'                                                   */
/* ---------------------------------------------------------------------- */

/** riempie l'array passato di valori interi pseudo-casuali tra  
    0 e max_val */
void riempi_array_random(int arr[], const unsigned int dim, int max_val)
{
  for (int i=0; i<dim; ++i) arr[i] = rand() % (max_val+1);
}


void stampa_array(int arr[], const unsigned int dim)
{
  for (int i=0; i<dim; ++i) cout << arr[i] << " ";
}

/* ---------------------------------------------------------------------- */
/* Esercizi svolti                                                        */
/* ---------------------------------------------------------------------- */


/** Cerca nell'array arr se esiste l'elemento val. Ignora gli
    indici in arr che sono gia' stati annotati nell'array K
    passato. Se val e' trovato, la sua posizione viene annotata in
    K in modo da non essere ritrovato nelle chiamate successive.
    La dimensione di arr e arrK e' data mediante il paramentro
    dim.

    Restituisce true se val e' trovato in una posizione non
    annotata, false altrimenti. */
bool fun2(const int arr[], const unsigned int dim, int val, bool arrK[])
{
  for (int i=0; i<dim; ++i) {
    if (arr[i] == val && !arrK[i]) {
      // trovato, annota e restituisci true
      arrK[i] = true; 
      return true;
    }
  }

  return false; // non trovato
}


/** Funzione principale. Verifica se tutti gli elementi in A sono presenti 
    distintamente anche in B */
bool fun1(const int arrA[], const unsigned int dimA, 
          const int arrB[], const unsigned int dimB)
{
  // crea e init l'array K
  bool arrK[dimB];
  for (int i=0; i<dimB; ++i) arrK[i] = false;

  for (int i=0; i<dimA; ++i) {
    if (!fun2(arrB, dimB, arrA[i], arrK)) return false;
  }
 
  // guardando il contenuto di arrK qui, sarebbe possibile anche 
  // sapere quali elementi di B non hanno corrispondenza in A
 
  return true;
}


int main()
{
  const int maxAval = 5;
  const int maxBval = 5;
  const unsigned int dimA = 5;
  const unsigned int dimB = 12;

  int arrA[dimA];
  int arrB[dimB];

  // setta il seed:
  srand(getpid());

  riempi_array_random(arrA, dimA, maxAval);
  riempi_array_random(arrB, dimB, maxBval);

  cout << "arrA = [ ";
  stampa_array(arrA, dimA);
  cout << " ]\n";

  cout << "arrB = [ ";
  stampa_array(arrB, dimB);
  cout << " ]\n";

  bool is_in = fun1(arrA, dimA, arrB, dimB);
  cout << "L'array A " << (is_in ? "e'" : "non e'")
       << " contenuto in B\n";
  
  return 0;
}
