#include <iostream>
using namespace std;

/* ---------------------------------------------------------------------- */
/* Funzioni di utilita'                                                   */
/* ---------------------------------------------------------------------- */

/** riempie l'array passato di valori interi pseudo-casuali tra  
    0 e max_val */
void riempi_array_random(int arr[], const unsigned int dim, int max_val)
{
  for (int i=0; i<dim; ++i) arr[i] = rand() % (max_val+1);
}


void stampa_array(int arr[], const unsigned int dim)
{
  for (int i=0; i<dim; ++i) {
    cout << arr[i];
    // allinea le cifre (si assumono valori minori di 1000) una
    // soluzioni piu' generale userebbe il log base 10 oppure in
    // C++ sui possono utilizzare i modificatori degli stream di
    // output (non in programma del corso).

    if (arr[i] < 10) cout << "   "; // una cifra
    else if (arr[i] < 100) cout << "  "; // due cifre
    else cout << " "; // tre cifre
  }    
}

/* ---------------------------------------------------------------------- */
/* Esercizi svolti                                                        */
/* ---------------------------------------------------------------------- */

/** Scrivere una funzione che prende in ingresso un array A di
    interi e la sua dimensione, e ritorna il valore corrispondente
    al valore massimo all' interno dell'array. */
int fun1(const int arr[], const unsigned int dim)
{
  int max = (dim>0) ? arr[0] : 0;
  for (int i=1; i<dim; ++i) if (arr[i] > max) max = arr[i];
  return max;
}

/** Scrivere una funzione che prende in ingresso un array A di
    interi e la sua dimensione, e ritorna il valore corrispondente
    al valore minimo all' interno dell'array. */
int fun2(const int arr[], const unsigned int dim)
{
  int min = (dim>0) ? arr[0] : 0;
  for (int i=1; i<dim; ++i) if (arr[i] < min) min = arr[i];
  return min;
}

/** Scrivere una funzione che prende in ingresso una
    matrice di interi di dimensione dim x 10, e il valore dim, e
    usa le due funzioni sopra per calcolare il valore minimo e
    massimo della matrice. 
    
    La procedura utilizza mmin e mmax come parametri di output per 
    calcolare i due risultati attesi. 
*/
const unsigned int MATR_SIZE = 10;
void fun3(const int matr[][MATR_SIZE], const unsigned int dim, 
          int &mmin, int &mmax)
{
  mmax = (MATR_SIZE > 0) ? fun1(matr[0], dim) : 0;
  mmin = (MATR_SIZE > 0) ? fun2(matr[0], dim) : 0;

  for (int i=1; i<MATR_SIZE; ++i) {
    int rmax = fun1(matr[i], dim);
    int rmin = fun2(matr[i], dim);
    if (rmax > mmax) mmax = rmax;
    if (rmin < mmin) mmin = rmin;
  }  
}



int main()
{
  const unsigned int dim = 5;
  const int max_val = 1000;

  int matrix[dim][MATR_SIZE];

  // set seed
  srand(getpid());
  
  // init matrix
  for (int i=0; i<MATR_SIZE; ++i) {
    riempi_array_random(matrix[i], dim, max_val);
  }

  // stampa matrix
  for (int i=0; i<MATR_SIZE; ++i) {
    stampa_array(matrix[i], dim);
    cout << endl;
  }
  cout << endl;

  int min, max;
  fun3(matrix, dim, min, max);

  cout << "Min=" << min << " max=" << max << endl;
 
  return 0;
}
